Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Types.h	(revision 82)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Types.h	(revision 82)
@@ -0,0 +1,194 @@
+#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_read_unit_read_unit_read_queue_Types_h
+#define morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_read_unit_read_unit_read_queue_Types_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace multi_read_unit {
+namespace read_unit {
+namespace read_queue {
+  
+  class Tread_queue_entry_t
+  {
+  public    : Tcontext_t         _context_id   ;
+  public    : Tcontext_t         _front_end_id ;
+  public    : Tcontext_t         _ooo_engine_id;
+  public    : Tpacket_t          _rob_id       ;
+  public    : Toperation_t       _operation    ;
+  public    : Ttype_t            _type         ;
+  public    : Tlsq_ptr_t         _store_queue_ptr_write;
+  public    : Tlsq_ptr_t         _load_queue_ptr_write;
+  public    : Tcontrol_t         _has_immediat ;
+  public    : Tgeneral_data_t    _immediat     ;
+  public    : Tcontrol_t         _read_ra      ;
+  public    : Tgeneral_address_t _num_reg_ra   ;
+  public    : Tcontrol_t         _read_rb      ;
+  public    : Tgeneral_address_t _num_reg_rb   ;
+  public    : Tcontrol_t         _read_rc      ;
+  public    : Tspecial_address_t _num_reg_rc   ;
+  public    : Tcontrol_t         _write_rd     ;
+  public    : Tgeneral_address_t _num_reg_rd   ;
+  public    : Tcontrol_t         _write_re     ;
+  public    : Tspecial_address_t _num_reg_re   ;
+
+    friend std::ostream& operator<< (std::ostream& output_stream,
+				morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Tread_queue_entry_t & x)
+    {
+      output_stream << " * _context_id            : " << toString(x._context_id   ) << std::endl
+		    << " * _front_end_id          : " << toString(x._front_end_id ) << std::endl
+		    << " * _ooo_engine_id         : " << toString(x._ooo_engine_id) << std::endl
+		    << " * _rob_id                : " << toString(x._rob_id       ) << std::endl
+		    << " * _operation             : " << toString(x._operation    ) << std::endl
+		    << " * _type                  : " << toString(x._type         ) << std::endl
+		    << " * _store_queue_ptr_write : " << toString(x._store_queue_ptr_write) << std::endl
+		    << " * _load_queue_ptr_write  : " << toString(x._load_queue_ptr_write ) << std::endl
+		    << " * _has_immediat          : " << toString(x._has_immediat ) << std::endl
+		    << " * _immediat              : " << toString(x._immediat     ) << std::endl
+		    << " * _read_ra               : " << toString(x._read_ra      ) << std::endl
+		    << " * _num_reg_ra            : " << toString(x._num_reg_ra   ) << std::endl
+		    << " * _read_rb               : " << toString(x._read_rb      ) << std::endl
+		    << " * _num_reg_rb            : " << toString(x._num_reg_rb   ) << std::endl
+		    << " * _read_rc               : " << toString(x._read_rc      ) << std::endl
+		    << " * _num_reg_rc            : " << toString(x._num_reg_rc   ) << std::endl
+		    << " * _write_rd              : " << toString(x._write_rd     ) << std::endl
+		    << " * _num_reg_rd            : " << toString(x._num_reg_rd   ) << std::endl
+		    << " * _write_re              : " << toString(x._write_re     ) << std::endl
+		    << " * _num_reg_re            : " << toString(x._num_reg_re   ) << std::endl;
+
+      return output_stream;
+    }
+
+  };
+
+  class Tread_queue_head_entry_t
+  {
+  public    : Tcontext_t         _context_id   ;
+  public    : Tcontext_t         _front_end_id ;
+  public    : Tcontext_t         _ooo_engine_id;
+  public    : Tpacket_t          _rob_id       ;
+  public    : Toperation_t       _operation    ;
+  public    : Ttype_t            _type         ;
+  public    : Tlsq_ptr_t         _store_queue_ptr_write;
+  public    : Tlsq_ptr_t         _load_queue_ptr_write;
+  public    : Tcontrol_t         _has_immediat ;
+  public    : Tgeneral_data_t    _immediat     ;
+  public    : Tcontrol_t         _read_ra      ;
+  public    : Tcontrol_t         _read_ra_val  ; // 1 : must access at the registerFile (after access, is set at 0)
+  public    : Tgeneral_address_t _num_reg_ra   ;
+  public    : Tcontrol_t         _data_ra_val  ; // 1 : the read of registerFile is valid
+  public    : Tgeneral_data_t    _data_ra      ;
+  public    : Tcontrol_t         _read_rb      ;
+  public    : Tcontrol_t         _read_rb_val  ;
+  public    : Tgeneral_address_t _num_reg_rb   ;
+  public    : Tcontrol_t         _data_rb_val  ;
+  public    : Tgeneral_data_t    _data_rb      ;
+  public    : Tcontrol_t         _read_rc      ;
+  public    : Tcontrol_t         _read_rc_val  ;
+  public    : Tspecial_address_t _num_reg_rc   ;
+  public    : Tcontrol_t         _data_rc_val  ;
+  public    : Tspecial_data_t    _data_rc      ;
+  public    : Tcontrol_t         _write_rd     ;
+  public    : Tgeneral_address_t _num_reg_rd   ;
+  public    : Tcontrol_t         _write_re     ;
+  public    : Tspecial_address_t _num_reg_re   ;
+
+#undef  FUNCTION 
+#define FUNCTION "Tread_queue_head_entry_t::operator="
+  public    : Tread_queue_head_entry_t& operator=(Tread_queue_entry_t x)
+    {
+      log_printf(FUNC,Read_queue,FUNCTION,"Begin");
+	  
+      _context_id   = x._context_id   ;
+      _front_end_id = x._front_end_id ;
+      _ooo_engine_id= x._ooo_engine_id;
+      _rob_id       = x._rob_id       ;
+      _operation    = x._operation    ;
+      _type         = x._type         ;
+      _store_queue_ptr_write = x._store_queue_ptr_write;
+      _load_queue_ptr_write  = x._load_queue_ptr_write ;
+      _has_immediat = x._has_immediat ;
+      _immediat     = x._immediat     ;
+      _read_ra      = x._read_ra      ;
+      _read_ra_val  = x._read_ra == 1 ; //if not must read, the registerFile is already access
+      _num_reg_ra   = x._num_reg_ra   ;
+      _data_ra_val  = x._read_ra == 0 ; //if not must read, the data is already valid
+      _data_ra      = 0               ;
+      _read_rb      = x._read_rb      ;
+      _read_rb_val  = x._read_rb == 1 ;
+      _num_reg_rb   = x._num_reg_rb   ;
+      _data_rb_val  = x._read_rb == 0 ;
+      _data_rb      = 0               ;
+      _read_rc      = x._read_rc      ;
+      _read_rc_val  = x._read_rc == 1 ;
+      _num_reg_rc   = x._num_reg_rc   ;
+      _data_rc_val  = x._read_rc == 0 ;
+      _data_rc      = 0               ;
+      _write_rd     = x._write_rd     ;
+      _num_reg_rd   = x._num_reg_rd   ;
+      _write_re     = x._write_re     ;
+      _num_reg_re   = x._num_reg_re   ;
+
+      log_printf(FUNC,Read_queue,FUNCTION,"End");
+
+      return *this;
+    }
+
+    friend std::ostream& operator<< (std::ostream& output_stream,
+				morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Tread_queue_head_entry_t & x)
+    {
+      output_stream << " * _context_id            : " << x._context_id   << std::endl
+		    << " * _front_end_id          : " << x._front_end_id << std::endl
+		    << " * _ooo_engine_id         : " << x._ooo_engine_id<< std::endl
+		    << " * _rob_id                : " << x._rob_id       << std::endl
+		    << " * _operation             : " << x._operation    << std::endl
+		    << " * _type                  : " << x._type         << std::endl
+		    << " * _store_queue_ptr_write : " << toString(x._store_queue_ptr_write) << std::endl
+		    << " * _load_queue_ptr_write  : " << toString(x._load_queue_ptr_write ) << std::endl
+		    << " * _has_immediat          : " << x._has_immediat << std::endl
+		    << " * _immediat              : " << x._immediat     << std::endl
+		    << " * _read_ra               : " << x._read_ra      << std::endl
+		    << " * _read_ra_val           : " << x._read_ra_val  << std::endl 
+		    << " * _num_reg_ra            : " << x._num_reg_ra   << std::endl
+		    << " * _data_ra_val           : " << x._data_ra_val  << std::endl
+		    << " * _data_ra               : " << x._data_ra      << std::endl
+		    << " * _read_rb               : " << x._read_rb      << std::endl
+		    << " * _read_rb_val           : " << x._read_rb_val  << std::endl
+		    << " * _num_reg_rb            : " << x._num_reg_rb   << std::endl
+		    << " * _data_rb_val           : " << x._data_rb_val  << std::endl
+		    << " * _data_rb               : " << x._data_rb      << std::endl
+		    << " * _read_rc               : " << x._read_rc      << std::endl
+		    << " * _read_rc_val           : " << x._read_rc_val  << std::endl
+		    << " * _num_reg_rc            : " << x._num_reg_rc   << std::endl
+		    << " * _data_rc_val           : " << x._data_rc_val  << std::endl
+		    << " * _data_rc               : " << x._data_rc      << std::endl
+		    << " * _write_rd              : " << x._write_rd     << std::endl
+		    << " * _num_reg_rd            : " << x._num_reg_rd   << std::endl
+		    << " * _write_re              : " << x._write_re     << std::endl
+		    << " * _num_reg_re            : " << x._num_reg_re   << std::endl;
+
+      return output_stream;
+    }
+  };
+
+}; // end namespace read_queue
+}; // end namespace read_unit
+}; // end namespace multi_read_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue.cpp	(revision 82)
@@ -18,15 +18,19 @@
 
 
-#ifdef SYSTEMC
-  Read_queue::Read_queue (sc_module_name name,
+  Read_queue::Read_queue 
+  (
+#ifdef SYSTEMC
+   sc_module_name name,
 #else
-  Read_queue::Read_queue (string name,
+   std::string name,
 #endif
 #ifdef STATISTICS
-			      morpheo::behavioural::Parameters_Statistics            * param_statistics,
-#endif
-			      morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Parameters * param ):
-			      _name              (name)
-			      ,_param            (param)
+   morpheo::behavioural::Parameters_Statistics            * param_statistics,
+#endif
+   morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Parameters * param,
+   morpheo::behavioural::Tusage_t usage ):
+    _name              (name)
+    ,_param            (param)
+    ,_usage (usage)
   {
     log_printf(FUNC,Read_queue,"Read_queue","Begin");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_allocation.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_allocation.cpp	(revision 82)
@@ -23,5 +23,5 @@
     log_printf(FUNC,Read_queue,"allocation","Begin");
 
-    _component   = new Component ();
+    _component   = new Component (_usage);
 
     Entity * entity = _component->set_entity (_name       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/test.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/test.cpp	(revision 82)
@@ -6,38 +6,10 @@
  * Test
  */
+#define NB_ITERATION  2
+#define CYCLE_MAX     (2048*NB_ITERATION)
 
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/include/test.h"
 #include "Common/include/Test.h"
 #include "Common/include/BitManipulation.h"
-
-#define NB_ITERATION  2
-#define CYCLE_MAX     (2048*NB_ITERATION)
-
-#define LABEL(str)                                                                       \
-{                                                                                        \
-  cout << "{"+toString(static_cast<uint32_t>(sc_simulation_time()))+"} " << str << endl; \
-} while(0)
-
-static uint32_t cycle = 0;
-
-#define SC_START(cycle_offset)                                          \
-do                                                                      \
-{                                                                       \
-/*cout << "SC_START (begin)" << endl;*/                                 \
-                                                                        \
-  uint32_t cycle_current = static_cast<uint32_t>(sc_simulation_time()); \
-  sc_start(cycle_offset);                                               \
-  if (cycle_current != cycle)                                           \
-    {                                                                   \
-      cycle = cycle_current;                                            \
-      cout << "##########[ cycle "<< cycle << " ]" << endl;             \
-    }                                                                   \
-                                                                        \
-  if (cycle_current > CYCLE_MAX)                                        \
-    {                                                                   \
-      TEST_KO("Maximal cycles Reached");                                \
-    }                                                                   \
-/*cout << "SC_START (end  )" << endl;*/                                 \
-} while(0)
 
 void test (string name,
@@ -50,9 +22,11 @@
 #endif
 
-  Reservation_station * _Reservation_station = new Reservation_station (name.c_str(),
+  Reservation_station * _Reservation_station = new Reservation_station 
+    (name.c_str(),
 #ifdef STATISTICS
-					     _parameters_statistics,
+     _parameters_statistics,
 #endif
-					     _param);
+     _param,
+     USE_ALL);
   
 #ifdef SYSTEMC
@@ -354,5 +328,5 @@
   for (uint32_t iteration=0; iteration<NB_ITERATION; iteration ++)
     {
-      LABEL("Iteration "+toString(iteration));
+      LABEL("Iteration %d",iteration);
 
       int32_t percent_transaction_queue_in     = (rand()%50)+25;
@@ -507,5 +481,5 @@
 	      if (val)
 		{
-		  LABEL(" * GPR_WRITE     ["+toString(i)+"] - gpr["+toString(num_reg)+"]["+toString(ooo_engine)+"] <- "+toString(data));
+		  LABEL(" * GPR_WRITE     [%d] - gpr[%d][%d] <- 0x%x",i,num_reg,ooo_engine,data);
 		  can_gpr_use [ooo_engine][num_reg] = false;
 		  need_gpr [ooo_engine][num_reg]    = false;
@@ -533,5 +507,6 @@
 	      if (val == 1)
 		{
-		  LABEL(" * SPR_WRITE     ["+toString(i)+"] - spr["+toString(num_reg)+"]["+toString(ooo_engine)+"] <- "+toString(data));
+		  LABEL(" * SPR_WRITE     [%d] - spr[%d][%d] <- 0x%x",i,num_reg,ooo_engine,data);
+
 		  can_spr_use [ooo_engine][num_reg] = false;
 		  need_spr[ooo_engine][num_reg]     = false;
@@ -560,5 +535,5 @@
 	      if (gpr_val)
 		{
-		  LABEL(" * BYPASS_WRITE  ["+toString(i)+"] - gpr["+toString(gpr_num_reg)+"]["+toString(ooo_engine)+"] <- "+toString(gpr_data));
+		  LABEL(" * BYPASS_WRITE  [%d] - gpr[%d][%d] <- 0x%x",i,gpr_num_reg,ooo_engine,gpr_data);
 		  can_gpr_use [ooo_engine][gpr_num_reg] = false;
 		  need_gpr[ooo_engine][gpr_num_reg]     = false;
@@ -580,5 +555,6 @@
 	      if (spr_val)
 		{
-		  LABEL(" * BYPASS_WRITE  ["+toString(i)+"] - spr["+toString(spr_num_reg)+"]["+toString(ooo_engine)+"] <- "+toString(spr_data));
+		  LABEL(" * BYPASS_WRITE  [%d] - spr[%d][%d] <- 0x%x",i,spr_num_reg,ooo_engine,spr_data);
+
 		  can_spr_use [ooo_engine][spr_num_reg] = false;
 		  need_spr[ooo_engine][spr_num_reg]     = false;
@@ -608,5 +584,6 @@
 	      if (val)
 		{
-		  LABEL(" * BYPASS_MEMORY ["+toString(i)+"] - gpr["+toString(num_reg)+"]["+toString(ooo_engine)+"] <- "+toString(data));
+		  LABEL(" * BYPASS_MEMORY [%d] - spr[%d][%d] <- 0x%x",i,num_reg,ooo_engine,data);
+
 		  can_gpr_use [ooo_engine][num_reg] = false;
 		  need_gpr [ooo_engine][num_reg] = false;
@@ -622,5 +599,5 @@
 	      (out_INSERT_ACK->read() == 1))
 	    {
-	      LABEL("Accepted INSERT  number : "+toString(request_in));
+	      LABEL("Accepted INSERT  number : %d",request_in);
 	      request_in  ++;
 	    }
@@ -628,5 +605,5 @@
 	  for (uint32_t i=0; i<_param->_nb_inst_retire; i++)
 	    {
- 	      LABEL("Test     RETIRE "+toString(i)+" : "+toString(out_RETIRE_VAL[i]->read())+","+toString(in_RETIRE_ACK[i]->read()));
+ 	      LABEL("Test     RETIRE %d : %d,%d",i,out_RETIRE_VAL[i]->read(),in_RETIRE_ACK[i]->read());
 	      if ((out_RETIRE_VAL [i]->read() == 1) and
 		  ( in_RETIRE_ACK [i]->read() == 1))
@@ -637,5 +614,5 @@
 		  else
 		    rob_id = 0;
-		  LABEL("Accepted RETIRE ["+toString(i)+"] number : "+toString(rob_id)+", request number : "+toString(request_out));
+		  LABEL("Accepted RETIRE [%d] number : %d, request number : %d",i,rob_id,request_out);
 		  TEST(bool, request_out_wait [rob_id] , true);
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Reservation_station.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Reservation_station.h	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Reservation_station.h	(revision 82)
@@ -21,5 +21,5 @@
 #endif
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h"
-#include "Behavioural/include/Types.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Types.h"
 #ifdef STATISTICS
 #include "Behavioural/include/Stat.h"
@@ -29,4 +29,5 @@
 #include "Behavioural/include/Vhdl.h"
 #endif
+#include "Behavioural/include/Usage.h"
 
 namespace morpheo {
@@ -39,67 +40,4 @@
 namespace reservation_station {
 
-  class Treservation_station_entry_t
-  {
-  public    : Tcontext_t         _context_id     ;
-  public    : Tcontext_t         _front_end_id   ;
-  public    : Tcontext_t         _ooo_engine_id  ;
-  public    : Tpacket_t          _rob_id         ;
-  public    : Toperation_t       _operation   ;
-  public    : Ttype_t            _type        ;
-  public    : Tlsq_ptr_t         _store_queue_ptr_write;
-  public    : Tlsq_ptr_t         _load_queue_ptr_write ;
-  public    : Tcontrol_t         _has_immediat;
-  public    : Tgeneral_data_t    _immediat    ;
-//public    : Tcontrol_t         _read_ra     ;
-  public    : Tgeneral_address_t _num_reg_ra  ;
-  public    : Tcontrol_t         _data_ra_val ;
-  public    : Tgeneral_data_t    _data_ra     ;
-//public    : Tcontrol_t         _read_rb     ;
-  public    : Tgeneral_address_t _num_reg_rb  ;
-  public    : Tcontrol_t         _data_rb_val ;
-  public    : Tgeneral_data_t    _data_rb     ;
-//public    : Tcontrol_t         _read_rc     ;
-  public    : Tspecial_address_t _num_reg_rc  ;
-  public    : Tcontrol_t         _data_rc_val ;
-  public    : Tspecial_data_t    _data_rc     ;
-  public    : Tcontrol_t         _write_rd    ;
-  public    : Tgeneral_address_t _num_reg_rd  ;
-  public    : Tcontrol_t         _write_re    ;
-  public    : Tspecial_address_t _num_reg_re  ;
-
-    friend std::ostream& operator<< (std::ostream& output_stream,
-				morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::reservation_station::Treservation_station_entry_t & x)
-    {
-      output_stream << " * _context_id            : " << toString(x._context_id     ) << std::endl
-		    << " * _front_end_id          : " << toString(x._front_end_id   ) << std::endl
-		    << " * _ooo_engine_id         : " << toString(x._ooo_engine_id  ) << std::endl
-		    << " * _rob_id                : " << toString(x._rob_id         ) << std::endl
-		    << " * _operation             : " << toString(x._operation      ) << std::endl
-		    << " * _type                  : " << toString(x._type           ) << std::endl
-		    << " * _store_queue_ptr_write : " << toString(x._store_queue_ptr_write) << std::endl
-		    << " * _load_queue_ptr_write  : " << toString(x._load_queue_ptr_write ) << std::endl
-		    << " * _has_immediat          : " << toString(x._has_immediat   ) << std::endl
-		    << " * _immediat              : " << toString(x._immediat       ) << std::endl
-// 		    << " * _read_ra               : " << toString(x._read_ra        ) << std::endl
-		    << " * _num_reg_ra            : " << toString(x._num_reg_ra     ) << std::endl
-		    << " * _data_ra_val           : " << toString(x._data_ra_val    ) << std::endl
-		    << " * _data_ra               : " << toString(x._data_ra        ) << std::endl
-// 		    << " * _read_rb               : " << toString(x._read_rb        ) << std::endl
-		    << " * _num_reg_rb            : " << toString(x._num_reg_rb     ) << std::endl
-		    << " * _data_rb_val           : " << toString(x._data_rb_val    ) << std::endl
-		    << " * _data_rb               : " << toString(x._data_rb        ) << std::endl
-// 		    << " * _read_rc               : " << toString(x._read_rc        ) << std::endl
-		    << " * _num_reg_rc            : " << toString(x._num_reg_rc     ) << std::endl
-		    << " * _data_rc_val           : " << toString(x._data_rc_val    ) << std::endl
-		    << " * _data_rc               : " << toString(x._data_rc        ) << std::endl
-		    << " * _write_rd              : " << toString(x._write_rd       ) << std::endl
-		    << " * _num_reg_rd            : " << toString(x._num_reg_rd     ) << std::endl
-		    << " * _write_re              : " << toString(x._write_re       ) << std::endl
-		    << " * _num_reg_re            : " << toString(x._num_reg_re     ) << std::endl;
-
-      return output_stream;
-    }
-  };
-
   class Reservation_station 
 #if SYSTEMC
@@ -109,7 +47,7 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const std::string       _name;
-
+  protected : const std::string  _name;
   protected : const Parameters * _param;
+  private   : const Tusage_t     _usage;
 
 #ifdef STATISTICS
@@ -241,5 +179,7 @@
 						       morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
-						       Parameters                                  * param );
+						       Parameters                                  * param,
+						       morpheo::behavioural::Tusage_t                usage );
+
   public  :          ~Reservation_station             (void);
 					       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Types.h	(revision 82)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Types.h	(revision 82)
@@ -0,0 +1,95 @@
+#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_read_unit_read_unit_reservation_station_Types_h
+#define morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_read_unit_read_unit_reservation_station_Types_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace multi_read_unit {
+namespace read_unit {
+namespace reservation_station {
+
+  class Treservation_station_entry_t
+  {
+  public    : Tcontext_t         _context_id     ;
+  public    : Tcontext_t         _front_end_id   ;
+  public    : Tcontext_t         _ooo_engine_id  ;
+  public    : Tpacket_t          _rob_id         ;
+  public    : Toperation_t       _operation   ;
+  public    : Ttype_t            _type        ;
+  public    : Tlsq_ptr_t         _store_queue_ptr_write;
+  public    : Tlsq_ptr_t         _load_queue_ptr_write ;
+  public    : Tcontrol_t         _has_immediat;
+  public    : Tgeneral_data_t    _immediat    ;
+//public    : Tcontrol_t         _read_ra     ;
+  public    : Tgeneral_address_t _num_reg_ra  ;
+  public    : Tcontrol_t         _data_ra_val ;
+  public    : Tgeneral_data_t    _data_ra     ;
+//public    : Tcontrol_t         _read_rb     ;
+  public    : Tgeneral_address_t _num_reg_rb  ;
+  public    : Tcontrol_t         _data_rb_val ;
+  public    : Tgeneral_data_t    _data_rb     ;
+//public    : Tcontrol_t         _read_rc     ;
+  public    : Tspecial_address_t _num_reg_rc  ;
+  public    : Tcontrol_t         _data_rc_val ;
+  public    : Tspecial_data_t    _data_rc     ;
+  public    : Tcontrol_t         _write_rd    ;
+  public    : Tgeneral_address_t _num_reg_rd  ;
+  public    : Tcontrol_t         _write_re    ;
+  public    : Tspecial_address_t _num_reg_re  ;
+
+    friend std::ostream& operator<< (std::ostream& output_stream,
+				morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::reservation_station::Treservation_station_entry_t & x)
+    {
+      output_stream << " * _context_id            : " << toString(x._context_id     ) << std::endl
+		    << " * _front_end_id          : " << toString(x._front_end_id   ) << std::endl
+		    << " * _ooo_engine_id         : " << toString(x._ooo_engine_id  ) << std::endl
+		    << " * _rob_id                : " << toString(x._rob_id         ) << std::endl
+		    << " * _operation             : " << toString(x._operation      ) << std::endl
+		    << " * _type                  : " << toString(x._type           ) << std::endl
+		    << " * _store_queue_ptr_write : " << toString(x._store_queue_ptr_write) << std::endl
+		    << " * _load_queue_ptr_write  : " << toString(x._load_queue_ptr_write ) << std::endl
+		    << " * _has_immediat          : " << toString(x._has_immediat   ) << std::endl
+		    << " * _immediat              : " << toString(x._immediat       ) << std::endl
+// 		    << " * _read_ra               : " << toString(x._read_ra        ) << std::endl
+		    << " * _num_reg_ra            : " << toString(x._num_reg_ra     ) << std::endl
+		    << " * _data_ra_val           : " << toString(x._data_ra_val    ) << std::endl
+		    << " * _data_ra               : " << toString(x._data_ra        ) << std::endl
+// 		    << " * _read_rb               : " << toString(x._read_rb        ) << std::endl
+		    << " * _num_reg_rb            : " << toString(x._num_reg_rb     ) << std::endl
+		    << " * _data_rb_val           : " << toString(x._data_rb_val    ) << std::endl
+		    << " * _data_rb               : " << toString(x._data_rb        ) << std::endl
+// 		    << " * _read_rc               : " << toString(x._read_rc        ) << std::endl
+		    << " * _num_reg_rc            : " << toString(x._num_reg_rc     ) << std::endl
+		    << " * _data_rc_val           : " << toString(x._data_rc_val    ) << std::endl
+		    << " * _data_rc               : " << toString(x._data_rc        ) << std::endl
+		    << " * _write_rd              : " << toString(x._write_rd       ) << std::endl
+		    << " * _num_reg_rd            : " << toString(x._num_reg_rd     ) << std::endl
+		    << " * _write_re              : " << toString(x._write_re       ) << std::endl
+		    << " * _num_reg_re            : " << toString(x._num_reg_re     ) << std::endl;
+
+      return output_stream;
+    }
+  };
+
+}; // end namespace reservation_station
+}; // end namespace read_unit
+}; // end namespace multi_read_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station.cpp	(revision 82)
@@ -20,15 +20,20 @@
 #undef  FUNCTION
 #define FUNCTION "Reservation_station::Reservation_station"
+
+  Reservation_station::Reservation_station 
+  (
 #ifdef SYSTEMC
-  Reservation_station::Reservation_station (sc_module_name name,
+   sc_module_name name,
 #else
-  Reservation_station::Reservation_station (string name,
+   std::string name,
 #endif
 #ifdef STATISTICS
-			  morpheo::behavioural::Parameters_Statistics * param_statistics,
+   morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
-			  morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::reservation_station::Parameters * param ):
-			      _name              (name)
-			      ,_param            (param)
+   morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::reservation_station::Parameters * param,
+   morpheo::behavioural::Tusage_t                usage ):
+    _name   (name)
+    ,_param (param)
+    ,_usage (usage)
   {
     log_printf(FUNC,Reservation_station,FUNCTION,"Begin");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_allocation.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_allocation.cpp	(revision 82)
@@ -26,5 +26,5 @@
     log_printf(FUNC,Reservation_station,FUNCTION,"Begin");
 
-    _component   = new Component ();
+    _component   = new Component (_usage);
 
     Entity * entity = _component->set_entity (_name       
